package de.mattv.fileserver;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.web.filter.CommonsRequestLoggingFilter;

/*
trait FS {
    https://gitea.mattv.de/root/fileserver/src/commit/702c18673c9d23304d00beda1eb40b7ea748281d/src/server/fs.cxx#L147
    fn move_nodes(token: String, nodes: [u64], parent: u64) -> Option<String>;
}
*/

@EnableAsync
@EnableScheduling
@Configuration
public class SpringConfiguration {
    @Bean
    public CommonsRequestLoggingFilter loggingFilter() {
        CommonsRequestLoggingFilter filter = new CommonsRequestLoggingFilter();
        filter.setIncludeQueryString(true);
        filter.setIncludePayload(false);
        filter.setIncludeClientInfo(true);
        return filter;
    }
}
