package de.mattv.fileserver.routes.fs;

import de.mattv.fileserver.data.Node;
import de.mattv.fileserver.data.User;
import de.mattv.fileserver.util.NonNull;

import java.util.Arrays;
import java.util.Objects;
import java.util.Stack;

public class FsUtils {
    protected static long nodesSize(User user, long[] nodes) {
        long total = 0;
        Stack<Node> todo = new Stack<>();
        todo.addAll(Arrays.stream(nodes)
                .mapToObj(user.nodes::get)
                .filter(Objects::nonNull)
                .toList());

        while (!todo.empty()) {
            Node node = todo.pop();
            if (node.isFile) total += node.size;
            else todo.addAll(node.children);
        }

        return total;
    }

    protected static @NonNull String getPath(Node node) {
        StringBuilder path = new StringBuilder();
        while (node != null) {
            path.insert(0, node.name);
            path.insert(0, '/');
            node = node.parent;
        }
        return path.isEmpty() ? "/" : path.toString();
    }
}
